;********************************************************

;*                (C)07/1998 Easy Soft                  *

;********************************************************

;UWAGA:

;	Czasy aktualne dla rezonatora kwarcowego 4MHz

;********************************************************





	.TITLE	"PLYTKA STEROWNIKA ISD2560"

	.VERS	"ST6220"

	.ROMSIZE 2





;Deklaracje stalych programu

A		.DEF	0FFH!m	;Akumulator

X		.DEF	080H		;Rejestr indeksowy X

Y		.DEF	081H		;Rejestr indeksowy Y

V		.DEF	082H		;Rejestr danych V

W		.DEF	083H		;Rejestr danych W

DRA		.DEF	0C0H!m	;Rejestr danych portu A

DRB		.DEF	0C1H		;Rejestr danych portu B

DRC		.DEF	0C2H		;Rejestr danych portu C

DDRA		.DEF	0C4H		;Rejestr kierunku portu A

DDRB		.DEF	0C5H		;Rejestr kierunku portu B

DDRC		.DEF	0C6H		;Rejestr kierunku portu C

IOR		.DEF	0C8H!m	;Rejestr trybu pracy przerwan

DRWR		.DEF	0C9H		;Rejestr danych okna ROM

ORA		.DEF	0CCH		;Rejestr trybu pracy portu A

ORB		.DEF	0CDH		;Rejestr trybu pracy portu B

ORC		.DEF	0CEH		;Rejestr trybu pracy portu C

ADR		.DEF	0D0H		;Rejestr danych przetwornika A/D.

ADCR		.DEF	0D1H		;Rejestr kontrolny przetw.A/D

PSC		.DEF	0D2H		;Rejestr preskalera zegara

TCR		.DEF	0D3H		;Rejestr licznika zegara

TSCR		.DEF	0D4H!m	;Rejestr kontrolny statusu zegara

WDR		.DEF	0D8H		;Rejestr ukladu Watchdog



;Deklaracje zajetosci komrek pamieci RAM mikrokomputera

COPY_PA	.DEF	084H

COPY_PB	.DEF	085H

COPY_A	.DEF	086H

RINGCNT	.DEF	087H		;Licznik wywolan ("dzwonkw")

CNT1		.DEF	088H		;Zmienne-liczniki pomocnicze

M10CNT	.DEF	089H		;Licznik 10 ms dla przerwania timer'a

SEC		.DEF	090H		;Licznik sekund

STAKBD	.DEF	091H		;Stan klawiatury

VOICCNT	.DEF	092H		;Licznik powtrzen komunikatu



;Deklaracje symboli dotyczacych ilosci powtrzen i petli czasowych

RING_1	.EQU	2		;Ilosc dzwonkw dla PB1="0"

RING_2	.EQU	5		;Ilosc dzwonkw dla PB1="1"

PLAY_1	.EQU	2		;Ilosc odtwarzanych komunikatw PB2="0"

PLAY_2	.EQU	3		;Ilosc odtwarzanych komunikatw PB2="1"

RING_TM	.EQU	25		;Czas trwania sygnalu wywolania w 100ms



;Numery bitw portu odpowiadajace sygnalom

;W przypadku zmiany numerw bitw (np. zmiana mozaiki) nalezy w 

;tym miejscu programu podac odpowiednie numery bitw

;*port PB

S_RUN		.EQU	0		;Wlaczenie toru m.cz./ladowania baterii

J_RING	.EQU	1		;Liczba wywolan do "odebrania" (SW4/2)

J_VOICE	.EQU	2		;Liczba powtrzen komunikatu (SW4/1)



S_CE		.EQU	3		;Sygnal wyboru ukladu ISD (Chip Enable)

S_OFV		.EQU	4		;Sygnal przepelnienia ISD (Overflow)

S_EOM		.EQU	5		;Koniec nagrania ISD(End Of Message)

S_PD		.EQU	6		;Sygnal "usypiajacy" (Power Down)

S_PR		.EQU	7		;Sygnal wyboru trybu (Play/Rec)



;*port PA

S_RING	.EQU	0		;Sygnal wywolania

K_PLAY	.EQU	1		;Klawisz PLAY

K_STOP	.EQU	1		;Klawisz STOP

K_REC		.EQU	2		;Klawisz REC

S_LED		.EQU	3		;Dioda sygnalizujaca prace





;Czas od aktywnosci do "uspienia" w sekundach

SLEEPTM	.EQU	10





;Wektory przerwan

;Wektor przerwania zawiera rozkaz skoku do okreslonego programu obslugi

;Dla ukladu ST6200 wektory te sa stale i nie mozna ich zmienic

.ORG	0FF0H

IT_ADC	NOP			;Przerwanie z przetwornika A/D

		RETI			;Powrt z obslugi przerwania

IT_TMR	JP	IRQ_TMR	;Przerwanie ukladu zegarowego 

					;- skocz do IRQ_TMR

IT_PBC	NOP			;Przerwanie z portu B lub C - nic nie rb

		RETI

IT_PA		JP	IRQ_PA	;Przerwanie z portu A

		NOP			;Zarezerwowane

		NOP			;

		NOP			;

		NOP			;

NMI		NOP			;Przerwanie niemaskowalne - nic nie rb

		RETI			;

RES		JP	INIT		;Wektor obslugi programu po RESET





.ORG	880H

;Przerwanie zegarowe sluzy do skasowania licznika wywolan (dzwonkw)

;Uruchamiane w momencie wywolania, blokowane po skasowaniu licznika

;wywolan RINGCNT

;W nim rwniez wlasciwy rozkaz uspienia ukladu STOP. WAIT umieszczone

;w petli glwnej nie powoduje uspienia a jedynie oczekiwanie na

;przerwanie, ktre moze pochodzic z dowolnego miejsca

IRQ_TMR	LD	COPY_A,A	;Przechowanie zawartosci akumulatora na 

					;czas obslugi przerwania

					;Przerwanie nastepuje w dowolnym stanie

					;programu, totez konieczne zapamietanie 

		LDI	TCR,0FFH	;stanu rejestru A

		RES	7,TSCR	;Start nowego odliczania

		INC	M10CNT	;Dziesiate czesci sekundy

		LD	A,M10CNT

		CPI	A,10		;Jesli 10 dziesiatych to cala sekunda

		JRZ	IQ_TMR1

		JP	IQ_TMR2

IQ_TMR1	CLR	M10CNT

		INC	SEC

		LD	A,SEC		;Czy minelo okolo SLEEPTM sekund od 

					;ostatniego wywolania?

		SUBI	A,SLEEPTM

		JRC	IQ_TMR2

		CLR	RINGCNT	;Jesli tak-skasuj licznik wywolan

		STOP			;"Uspienie" ukladu, zatrzymanie zegara

IQ_TMR2	LD	A,COPY_A

		RETI			;Powrt do programu glwnego





;Przerwanie z portu PA. Sluzy do "obudzenia" procesora z trybu STOP

;oraz testowania rodzaju wywolania 

;Stan portu PA zostaje zapamietany w pamieci RAM w zmiennej STAKBD

IRQ_PA	LD	COPY_A,A	;Przechowanie akumulatora w COPY_A

		LD	A,DRA		;Odczyt stanu PA

		ANDI	A,07H		;Maskowanie bitw 3 do 7

		LD	STAKBD,A	;Zapamietanie stanu sygnalw "budzacych"

IRQ_PA1	LD	A,COPY_A	;Wyjscie z procedury i odtworzenie A

		RETI





;Poczatek programu glwnego, inicjalizacja rejestrw,

;programowanie trybw pracy rejestrw

INIT		RETI			;Koniec obslugi przerwania po reset

		RES	0,WDR		;Wylaczenie Watchdog'a

		CLR	RINGCNT	;Kasowanie wywolan

		LDI	TCR,0FFH	;Maksymalny wsplczynnik podzialu

		LDI	TSCR,06FH	;TMZ=0,przerw.wlaczone,preskaler=128

					;IRQ_TMR sa wstrzymywane przez STOP

		CLR	ADCR		;Wylaczenie przetwornika A/D

		CLR	SEC		;Kasowanie licznika sekund

		CLR	M10CNT	;Kasowanie licznika dziesiatek sekund



;Programowanie rejestru PA 

		LDI	DDRA,08H	;PA0-wejscie(transoptor REQ)

		LDI	ORA,07H	;PA1-wejscie(klawisz PLAY)

		LDI	DRA,08H 	;PA2-wejscie(klawisz REC);

					;PA3-out(dioda LED)

;Programowanie rejestru PB

		LDI	DDRB,0C9H	;PB0-wyjscie(sygnal READY)

		LDI	ORB,081H	;PB1,PB2-wejscie(przelacznik DIPSW)

		LDI	DRB,0CEH	;PB3-wyjscie(CE),PB4 wejscie(OFV),

					;PB5-wejscie(EOM),PB6-wyjscie(PD)

					;PB7-wyjscie(P/R)



		SET	4,IOR		;Zezwolenie na przyjmowanie przerwan



MAIN		LDI	DDRA,08H	;"Odswiezenie" PA(bez tego procesor nie

					;chcial sie "budzic"(?!))

		LDI	ORA,07H

		LDI	DRA,08H

		WAIT			;Wlasciwe "usypianie" umieszczone w

					;obsludze przerwan zegara (po 7 sek.)-

					;tutaj tylko oczekiwanie na przerwanie 

					;zegara

					;Istotne jest to,ze funkcjonuje przerw.

					;zegara, ktre odmierza czas

		CALL	AKCJA		;Podjecie akcji w zaleznosci od STAKBD

		JP	MAIN







;Procedura AKCJA korzysta z bitw zmiennej STAKBD rozpatrujac ich 

;stan i w zaleznosci od ich wartosci podejmujac odpowiednie dzialanie

AKCJA		JRS	S_RING,STAKBD,AKCJA_1	;Sygnal dzwonienia

		CALL	RUN_ON		;Zapalenie diody LED

		CLR	SEC			;Kasowanie licznika sekund

		INC	RINGCNT		;Zwiekszenie licznika wywolan



AKPAUSE	LD	A,SEC			;Odczekujemy okolo 2 sekundy

		CPI	A,2

		JRNZ	AKPAUSE



		SET	J_RING,DRB		;Odczyt nastaw SW4 poprzez

		SET	J_VOICE,DRB		;wystawienie "1" i badanie zwarcia 

		LD	A,DRB			;do masy

		LD	COPY_PB,A



		LD	A,RINGCNT		;Do akumulatora licznik wywolan

		JRS	J_RING,COPY_PB,AKRNG_1

		SUBI	A,RING_1		;Praca jako odzewnik - mniejsza 						;liczba dzwonkw

		JRNC	AKRNG_2

		JP	AKCJA_3		;Wyjscie, bo zbyt malo wywolan

AKRNG_1	SUBI	A,RING_2		;Praca jako informator-wieksza 

						;liczba dzwonkw

		JRNC	AKRNG_2

		JP	AKCJA_3		;Wyjscie, bo zbyt malo wywolan

						;oczekiwanie na nastepne a jesli

						;ich nie bedzie, to przerwanie 

						;timer'a wyzeruje licznik wywolan



;Odtwarzanie komunikatu po odpowiedniej liczbie dzwonkw

AKRNG_2	JRS	J_VOICE,COPY_PB,AKRNG_3

		LDI	VOICCNT,PLAY_1	;Mniejsza liczba kom.<-j_voice=0

		JP	AKRNG_4

AKRNG_3	LDI	VOICCNT,PLAY_2	;Wieksza liczba kom.<- j_voice=1

AKRNG_4	CALL	AMP_ON		;Wlaczenie toru m.cz.

		CALL	PLAY			;Odczyt komunikatu z ukladu ISD

		DEC	VOICCNT		;Odtworzenie kom.VOICCNT razy

		JRNZ	AKRNG_4

		CALL	AMP_OFF		;Wylaczenie toru m.cz.

		JP	AKCJA_3		;Koniec

		

;Reakcja na nacisniecie klawisza "PLAY/STOP"

AKCJA_1	JRS	K_PLAY,STAKBD,AKCJA_2	;Nacisniecie PLAY

		CALL	RUN_ON		;Wlaczenie sygnalizacji LED

		CALL	AMP_ON		;Wlaczenie toru m.cz.

		CALL	PLAY			;Odtworzenie komunikatu

		CALL	AMP_OFF		;Wylaczenie toru m.cz.

		JP	AKCJA_3

	

;Reakcja na nacisniecie klawisza "REC"

AKCJA_2	JRS	K_REC,STAKBD,AKCJA_3	;Nacisniecie REC

		CALL	RUN_ON		;Wlaczenie sygnalizacji LED

		CALL	REC			;Uruchomienie procedury nagryw.

AKCJA_3	CALL	RUN_OFF		;Wylaczenie sygnalizacji LED

		LDI	STAKBD,0FFH		;W celu unikniecia przypadkowych

						;reakcji programu

		RET







;PROCEDURA ZAPISU/PRZEPIEGI CZASOWE NA WYPROWADZENIACH ISD2560:

; MIC   ----------------/\/\/\/\/\/\/\/\----

;   _                  :                :

; P/R	-\_____________:________________:___	(S_PR)

;        : 10ms :      :                :

; PD    -:------\_30ms_:________________:___	(S_PD)

; __     :      :      :                :

; CE	---------------\________________/---	(S_CE)



REC		LD	A,DRB

		LD	COPY_PB,A		;Zapamietanie stanu PB w COPY_PB

		SET	S_CE,COPY_PB	;CE = "1"

		SET	S_PD,COPY_PB	;PD = "1"

		RES	S_PR,COPY_PB	;PR = "0"

		SET	S_OFV,COPY_PB	;OFV = "1"

		CALL	OUT_PB		;Stan COPY_PB do portu PB

		CALL	MS_10			;Zwloka ok. 10 ms



		RES	S_PD,COPY_PB	;PD = "0"

		CALL	OUT_PB

		CALL	MS_10

		CALL	MS_10

		CALL	MS_10			;Zwloka ok. 30 ms



		RES	S_CE,COPY_PB	;CE = "0"

		CALL	OUT_PB



		RES	K_PLAY,ORA		;Wylaczenie przyjmowania przerwan

		RES	K_REC,ORA

REC_1		CLR	SEC			;Koniec zapisu:

		JRR	K_STOP,DRA,REC_3	; -Jesli nacisnieto "STOP(PLAY)"

		JRR	S_OFV,DRB,REC_4	; -Jesli wystapi OFV



;---------- mruganie diody LED -------------------

		LD	A,M10CNT		;Do akumulatora licznik 0,1 sek.

		SUBI	A,5			;Odejmij od akumulatora 5

		JRC	REC_5			;Jesli przeniesienie to zgas LED

		CALL	RUN_ON		;Zapal LED

		JP	REC_1

REC_5		CALL	RUN_OFF

;-------------------------------------------

		JP	REC_1



REC_3		CALL	MS_10			;Ponowny test klawisza po 10 ms

		JRR	K_STOP,DRA,REC_4

		JP	REC_1



;Zakonczenie zapisu

REC_4		SET	S_CE,COPY_PB	;CE = "1"

		CALL	OUT_PB		;Wyprowadz na PB

		CALL	MS_10



		SET	S_PD,COPY_PB	;PD = "1"

		SET	S_PR,COPY_PB	;PR = "1"

		CALL	OUT_PB		;Wyprowadz na PB

		SET	K_PLAY,ORA		;Zalaczenie przerwan z PA

		SET	K_REC,ORA

		RET







;ODCZYT:

; SPK   -----------------/\/\/\/\/\/\/\/\----

;   _                   :                :

; P/R	/---------------:----------------:---	(S_PR)

;         : 10ms :      :                :

; PD    /-:------\_30ms_:________________:___	(S_PD)

; __      :      :      :                :

; CE	/---------------\________________:/--   (S_CE)  

; Zatrzymanie odczytu po sygnale EOM lub OVF z ISD25..

;Sygnal OVF powiela sygnal CE po przepelnieniu pamieci!!!



PLAY		LD	A,DRB

		LD	COPY_PB,A		;Zapamietanie stanu PB w 

		SET	S_PR,COPY_PB	;PR = "1"

		SET	S_PD,COPY_PB	;PD = "1"

		SET	S_CE,COPY_PB	;CE = "1"

		SET	S_OFV,COPY_PB	;OFV = "1"

		CALL	OUT_PB		;Wyprowadz na PB

		CALL	MS_10			;Odczekaj ok. 10 ms



		RES	S_PD,COPY_PB	;PD = "0"

		CALL	OUT_PB		

		CALL	MS_10

		CALL	MS_10

		CALL	MS_10			;Odczekaj ok. 30 ms



		RES	S_CE,COPY_PB	;CE = "0"

		CALL	OUT_PB



		RES	K_PLAY,ORA		;Wylaczenie przyjmowania przerwan

		RES	K_REC,ORA

;Sygnal OVF powiela CE po przepelnieniu pamieci ISD (OVF=OVF+CE)!!!

PLY_1		CLR	SEC

		JRR	S_OFV,DRB,PLY_2	;Jesli przepelnienie to zakoncz

		JRR	S_EOM,DRB,PLY_2	;Jesli koniec komunikatu to zakoncz

		JRR	K_STOP,DRA,PLY_3	;Test klawisza "STOP"

		JP	PLY_1

PLY_3		CALL	MS_10			;Pauza 10ms i ponowny test klawisza

		JRR	K_STOP,DRA,PLY_2	;Wcisnieto STOP - koniec

		JP	PLY_1

	

PLY_2		SET	S_PD,COPY_PB	;PD = "0"

		SET	S_CE,COPY_PB	;CE = "0"

		CALL	OUT_PB

		SET	K_PLAY,ORA		;Wlacz przyjmowanie przerwan z PA

		SET	K_REC,ORA

		RET





;Zapamietanie stanw DRA i DRB w COPY_PA i COPY_PB

OUT_PA	LD	A,COPY_PA

		LD	DRA,A

		RET



OUT_PB	LD	A,COPY_PB

		LD	DRB,A

		RET





 ;Obsluga diody LED

RUN_ON	LD	A,DRA		;Dioda zapalona

		RES	S_LED,A

	 	LD	DRA,A

		RET



RUN_OFF	LD	A,DRA		;Dioda zgaszona

		SET	S_LED,A

		LD	DRA,A

		RET





;Wlaczenie / wylaczenie toru m.cz. (zasilania wzmacniacza LM386 oraz 

;aktywacja ukladu zasilania z linii telefonicznej

AMP_ON	LD	A,DRB		;Wzmacniacz zalaczony

		SET	S_RUN,A

		LD	DRB,A

		RET



AMP_OFF	LD	A,DRB		;Wzmacniacz wylaczony

		RES	S_RUN,A

		LD	DRB,A

		RET





;Opznienie/petla trwajaca okolo 10 ms

;Po sredniku podano liczbe cykli maszynowych potrzebnych na 

;zrealizowanie rozkazu (1 cykl maszynowy = czestotliwosc zegara/13)

MS_10	LDI	CNT1,0ABH		;4

MS10_1	LD	A,CNT1	;4

		ADDI	A,1		;4

		SUBI	A,2		;4

		LD	CNT1,A	;4

		JRNZ	MS10_1	;2

		RET			;2





.END



